// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMRPars.pas' rev: 5.00

#ifndef SMRParsHPP
#define SMRParsHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <TypInfo.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <SMRTypes.hpp>	// Pascal unit
#include <Db.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Smrpars
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum SMCANOp { canNOTDEFINED, canISBLANK, canNOTBLANK, canEQ, canNE, canGT, canLT, canGE, canLE, canNOT, 
	canAND, canOR, canFIELD2, canCONST2, canMINUS, canADD, canSUB, canMUL, canDIV, canMOD, canSUM, canCOUNT, 
	canMIN, canMAX, canAVG, canLIKE, canIN, canFUNC2, canLISTELEM2, canASSIGN };
#pragma option pop

typedef SMCANOp *PSMCANOp;

#pragma option push -b-
enum SMNODEClass { nodeNULL, nodeUNARY, nodeBINARY, nodeCOMPARE, nodeFIELD, nodeCONST, nodeLIST, nodeFUNC, 
	nodeLISTELEM };
#pragma option pop

struct SMCANExpr;
typedef SMCANExpr *PSMCANExpr;

typedef PSMCANExpr *PPSMCANExpr;

#pragma pack(push, 1)
struct SMCANExpr
{
	Word iVer;
	Word iTotalSize;
	Word iNodes;
	Word iNodeStart;
	Word iLiteralStart;
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct SMCANHdr
{
	SMNODEClass nodeClass;
	SMCANOp canOp;
} ;
#pragma pack(pop)

typedef SMCANHdr *PSMCANHdr;

#pragma option push -b-
enum TExprNodeKind { enField, enConst, enOperator, enFunc };
#pragma option pop

#pragma option push -b-
enum TExprScopeKind { skField, skAgg, skConst };
#pragma option pop

struct TExprNode;
typedef TExprNode *PExprNode;

struct TExprNode
{
	TExprNode *FNext;
	TExprNodeKind FKind;
	bool FPartial;
	SMCANOp FOperator;
	Variant FData;
	TExprNode *FLeft;
	TExprNode *FRight;
	int FDataType;
	int FDataSize;
	Classes::TList* FArgs;
	TExprScopeKind FScopeKind;
} ;

typedef void __fastcall (__closure *TGetVariableEvent)(System::TObject* Sender, AnsiString VariableName
	, bool &Accept, Db::TFieldType &VariableType, Variant &Value);

class DELPHICLASS TFilterExpr;
class PASCALIMPLEMENTATION TFilterExpr : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TGetVariableEvent FVariableEvent;
	Classes::TList* FDataSets;
	Db::TFilterOptions FOptions;
	TExprNode *FNodes;
	SMCANExpr *FExprBuffer;
	int FExprBufSize;
	int FExprNodeSize;
	int FExprDataSize;
	Db::TField* __fastcall FieldFromNode(PExprNode Node);
	char * __fastcall GetExprData(int Pos, int Size);
	int __fastcall PutConstBCD(const Variant &Value, int Decimals);
	int __fastcall PutConstBool(const Variant &Value);
	int __fastcall PutConstDate(const Variant &Value);
	int __fastcall PutConstDateTime(const Variant &Value);
	int __fastcall PutConstFloat(const Variant &Value);
	int __fastcall PutConstInt(int DataType, const Variant &Value);
	int __fastcall PutConstNode(int DataType, char * Data, int Size);
	int __fastcall PutConstStr(const AnsiString Value);
	int __fastcall PutConstTime(const Variant &Value);
	int __fastcall PutData(char * Data, int Size);
	int __fastcall PutExprNode(PExprNode Node, SMCANOp ParentOp);
	int __fastcall PutFieldNode(Db::TField* Field, PExprNode Node);
	int __fastcall PutNode(SMNODEClass NodeType, SMCANOp OpType, int OpCount);
	void __fastcall SetNodeOp(int Node, int Index, int Data);
	int __fastcall PutConstant(PExprNode Node);
	
public:
	__fastcall TFilterExpr(Classes::TList* DataSets, Db::TFilterOptions Options, TGetVariableEvent AGetVariableEvent
		);
	__fastcall virtual ~TFilterExpr(void);
	PExprNode __fastcall NewCompareNode(Db::TField* Field, SMCANOp Operator, const Variant &Value);
	PExprNode __fastcall NewNode(TExprNodeKind Kind, SMCANOp Operator, const Variant &Data, PExprNode Left
		, PExprNode Right);
	PSMCANExpr __fastcall GetFilterData(PExprNode Root);
	__property Classes::TList* DataSets = {write=FDataSets};
};


#pragma option push -b-
enum TExprToken { etEnd, etSymbol, etName, etLiteral, etLParen, etRParen, etEQ, etNE, etGE, etLE, etGT, 
	etLT, etADD, etSUB, etMUL, etDIV, etComma, etLIKE, etISNULL, etISNOTNULL, etIN };
#pragma option pop

class DELPHICLASS TExprParser;
class PASCALIMPLEMENTATION TExprParser : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TFilterExpr* FFilter;
	AnsiString FText;
	char *FSourcePtr;
	char *FTokenPtr;
	AnsiString FTokenString;
	AnsiString FStrTrue;
	AnsiString FStrFalse;
	TExprToken FToken;
	TExprToken FPrevToken;
	SMCANExpr *FFilterData;
	bool FNumericLit;
	int FDataSize;
	Classes::TList* FDataSets;
	void __fastcall NextToken(void);
	bool __fastcall NextTokenIsLParen(void);
	PExprNode __fastcall ParseExpr(void);
	PExprNode __fastcall ParseExpr2(void);
	PExprNode __fastcall ParseExpr3(void);
	PExprNode __fastcall ParseExpr4(void);
	PExprNode __fastcall ParseExpr5(void);
	PExprNode __fastcall ParseExpr6(void);
	PExprNode __fastcall ParseExpr7(void);
	AnsiString __fastcall TokenName();
	bool __fastcall TokenSymbolIs(const AnsiString S);
	bool __fastcall TokenSymbolIsFunc(const AnsiString S);
	void __fastcall GetFuncResultInfo(PExprNode Node);
	void __fastcall TypeCheckArithOp(PExprNode Node);
	void __fastcall GetScopeKind(PExprNode Root, PExprNode Left, PExprNode Right);
	Variant __fastcall EvalNode(PExprNode Node);
	
public:
	__fastcall TExprParser(Classes::TList* DataSets, const AnsiString Text, Db::TFilterOptions Options, 
		TGetVariableEvent AGetVariableEvent);
	__fastcall virtual ~TExprParser(void);
	void __fastcall SetExprParams(const AnsiString Text);
	Variant __fastcall Evaluate();
};


struct FMTBcd;
typedef FMTBcd *PFMTBcd;

#pragma pack(push, 1)
struct FMTBcd
{
	Byte iPrecision;
	Byte iSignSpecialPlaces;
	Byte iFraction[32];
} ;
#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
static const Shortint fldUNKNOWN = 0x0;
static const Shortint fldZSTRING = 0x1;
static const Shortint fldDATE = 0x2;
static const Shortint fldBLOB = 0x3;
static const Shortint fldBOOL = 0x4;
static const Shortint fldINT16 = 0x5;
static const Shortint fldINT32 = 0x6;
static const Shortint fldFLOAT = 0x7;
static const Shortint fldBCD = 0x8;
static const Shortint fldBYTES = 0x9;
static const Shortint fldTIME = 0xa;
static const Shortint fldTIMESTAMP = 0xb;
static const Shortint fldUINT16 = 0xc;
static const Shortint fldUINT32 = 0xd;
static const Shortint fldFLOATIEEE = 0xe;
static const Shortint fldVARBYTES = 0xf;
static const Shortint fldLOCKINFO = 0x10;
static const Shortint fldCURSOR = 0x11;
static const Shortint fldINT64 = 0x12;
static const Shortint fldUINT64 = 0x13;
static const Shortint fldADT = 0x14;
static const Shortint fldARRAY = 0x15;
static const Shortint fldREF = 0x16;
static const Shortint fldTABLE = 0x17;
static const Shortint fldDATETIME = 0x18;
static const Shortint fldFMTBCD = 0x19;
static const Shortint CANEXPRVERSION = 0x2;
extern PACKAGE Byte FldTypeMap[36];
extern PACKAGE Variant __fastcall EvaluateValue(Classes::TList* lstDS, AnsiString Expression, TGetVariableEvent 
	AGetVariableEvent);
extern PACKAGE Variant __fastcall GetCalculatedValue(Classes::TList* lstDS, const AnsiString Expression
	, const AnsiString Format, Smrtypes::TCalcType CalcType, const Variant &PrevValue, const Variant &CurValue
	, TGetVariableEvent AGetVariableEvent);

}	/* namespace Smrpars */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smrpars;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SMRPars
