// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'BarCode.pas' rev: 6.00

#ifndef BarCodeHPP
#define BarCodeHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Menus.hpp>	// Pascal unit
#include <SMRBase.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Barcode
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TBarCodeType { bcCode39, bcInterleaved2of5, bcPostnet, bcUPCA };
#pragma option pop

#pragma option push -b-
enum TBarType { btNarrow, btWide };
#pragma option pop

class DELPHICLASS TSMBarCode;
class PASCALIMPLEMENTATION TSMBarCode : public Smrbase::TSMRControl 
{
	typedef Smrbase::TSMRControl inherited;
	
private:
	TBarCodeType FBarCodeType;
	int FNarrowWidth;
	int FWideWidth;
	bool FVertical;
	AnsiString FValue;
	AnsiString FExpression;
	void __fastcall SetValue(AnsiString AValue);
	void __fastcall SetExpression(AnsiString AValue);
	AnsiString __fastcall GetBarCode();
	Byte __fastcall FindCode(char ch, const char * arrChar, const int arrChar_Size, const Byte * arrCode, const int arrCode_Size, int &intIndex);
	void __fastcall DrawCode39(Graphics::TCanvas* ACanvas);
	void __fastcall DrawInterleaved2of5(Graphics::TCanvas* ACanvas);
	void __fastcall DrawPostnet(Graphics::TCanvas* ACanvas);
	void __fastcall DrawUPCA(Graphics::TCanvas* ACanvas);
	void __fastcall DrawUPCLeftBars(Graphics::TCanvas* ACanvas, AnsiString NumSys);
	void __fastcall DrawUPCCenterBars(Graphics::TCanvas* ACanvas);
	void __fastcall DrawUPCRightBars(Graphics::TCanvas* ACanvas, AnsiString Chk);
	
protected:
	int intRecLeft;
	int intRecTop;
	int intRecHeight;
	int intRecWidth;
	void __fastcall DrawBarLine(Graphics::TCanvas* ACanvas, TBarType BarType, bool boolDraw, bool IsHalf);
	void __fastcall DrawBarString(Graphics::TCanvas* ACanvas, AnsiString BarString);
	void __fastcall DrawPostnetString(Graphics::TCanvas* ACanvas, AnsiString BarString);
	
public:
	__fastcall virtual TSMBarCode(Classes::TComponent* AOwner);
	virtual int __fastcall Draw(Graphics::TCanvas* ACanvas, Types::TRect &ARect, int intBandHeight, Word Flags);
	virtual bool __fastcall EditProperties(bool ShowPrevForm);
	
__published:
	__property TBarCodeType BarCodeType = {read=FBarCodeType, write=FBarCodeType, nodefault};
	__property AnsiString Value = {read=FValue, write=SetValue};
	__property AnsiString Expression = {read=FExpression, write=SetExpression};
	__property bool Vertical = {read=FVertical, write=FVertical, nodefault};
	__property int NarrowWidth = {read=FNarrowWidth, write=FNarrowWidth, nodefault};
	__property int WideWidth = {read=FWideWidth, write=FWideWidth, nodefault};
	__property Align  = {default=0};
	__property Caption ;
	__property Color  = {default=-2147483643};
	__property DragCursor  = {default=-12};
	__property DragMode  = {default=0};
	__property Enabled  = {default=1};
	__property Font ;
	__property ParentColor  = {default=1};
	__property ParentFont  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint ;
	__property Visible  = {default=1};
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDrag ;
public:
	#pragma option push -w-inl
	/* TSMRControl.Destroy */ inline __fastcall virtual ~TSMBarCode(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Barcode */
using namespace Barcode;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// BarCode
