unit SimpleGrp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  child, Db, DBTables, Grids, DBGrids, StdCtrls, PrintSM, SMRAuto, SMRBase,
  ComCtrls;

type
  TfrmSimpleGrp = class(TfrmChildParent)
    tcDataView: TTabControl;
    tvData: TTreeView;
    qryExample3: TQuery;
    ImageList: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure tcDataViewChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    IsFirstActive: Boolean;
  public
    { Public declarations }
    procedure FillTreeView;
  end;

implementation

{$R *.DFM}

procedure TfrmSimpleGrp.FormCreate(Sender: TObject);
begin
  inherited;

  SMReport.LoadReport(ExtractFilePath(Application.ExeName) + '\SimpleGrp.SMR');
  IsFirstActive := True
end;

procedure TfrmSimpleGrp.tcDataViewChange(Sender: TObject);
begin
  inherited;

  DBGrid.Visible := (tcDataView.TabIndex = 0);
  tvData.Visible := not DBGrid.Visible;

  if tvData.Visible and (tvData.Items.Count = 0) then
    FillTreeView;
end;

procedure TfrmSimpleGrp.FillTreeView;
var idCustNo: Integer;
    itemCustomer: TTreeNode;
begin
  Screen.Cursor := crHourglass;
  with qryExample3 do
  begin
    idCustNo := -1;
    First;
    while not Eof do
    begin
      if (idCustNo <> FieldByName('CustNo').AsInteger) then
      begin
        {add a node for customer name}
        idCustNo := FieldByName('CustNo').AsInteger;
        itemCustomer := tvData.Items.Add(nil, 'Customer: #' +
                                              IntToStr(idCustNo) + ',  ' +
                                              FieldByName('Company').AsString + ', ' +
                                              FieldByName('Contact').AsString + ', ph: ' +
                                              FieldByName('Phone').AsString);
        itemCustomer.ImageIndex := 0;
        itemCustomer.SelectedIndex := 0;

        {set a bold style for item}
        SetNodeBold(itemCustomer);
      end;

      with tvData.Items.AddChild(itemCustomer, 'Order: #' +
                                               FieldByName('OrderNo').AsString + ',  ' +
                                               FieldByName('SaleDate').AsString + ',  ' +
                                               FloatToStrF(FieldByName('AmountPaid').AsFloat, ffCurrency, 18, 2)) do
      begin
        ImageIndex := 1;
        SelectedIndex := 1;
      end;

      Next;
    end;
    First
  end;
  Screen.Cursor := crDefault;
end;

procedure TfrmSimpleGrp.FormActivate(Sender: TObject);
begin
  inherited;

  if IsFirstActive then
  begin
    IsFirstActive := False;

    ShowMessage('Don''t forget to press a TSMPrintData button on toolbar!'#13#13+
                'In this mode you can see the autogenerated report from DBGrid data with'#13+
                'column order, layout (width, alignments, fonts etc).'#13#13+
                'Also you can see a new features - "on-fly" grouping and calculations'#13+
                '(total by orders for each customer)!')
  end;
end;


end.
